<?php
	/**
	* Simple Comment System
	* @author Webito
	* @version 1.0.0
	* @copyright (C) 2008 by Webito
	* @license http://www.vanwebito.com/
	**/

	defined('_JEXEC') or die;
	class plgContentSimpleComment extends JPlugin{
	
		function plgContentSimpleComment( &$subject, $config ){
			parent::__construct( $subject, $config );
			JPlugin::loadLanguage( 'plg_content_simplecomment', JPATH_ADMINISTRATOR );
		}
		
		function onPrepareContent( &$article, &$params ){
			global $mainframe;
			
			$juser				= &JFactory::getUser();
			$plugin				= & JPluginHelper::getPlugin('content', 'simplecomment');
			$pluginParams		= new JParameter( $plugin->params );
			$pluginRegistry		= $pluginParams->_registry['_default']['data'];
	
			if($this->plgShowContent() == 1){
				if($this->plgAllowContent($article) == 1){
					$this->article = & $article;
					$scsReadMore	= $pluginRegistry->scs_readmore; //order list
					$scsReadMoreText= $pluginRegistry->scs_readmore_text; //order list
					if($this->article->readmore == ""){
						$scsSwfwidth	= $pluginRegistry->scs_width; //movie width
						$scsBender		= $pluginRegistry->scs_bender; //phpBender PHP file location
						$scsModGuest	= $pluginRegistry->scs_publish_guest; //moderate guest
						$scsModUser		= $pluginRegistry->scs_publish_user; //moderate user
						$scsOrder		= $pluginRegistry->scs_order; //order list
	
						//ADD HEAD TAG
						$headtag = "
							<link rel=\"stylesheet\" href=\"" . JURI::root(true) . "/plugins/content/simplecomment/comment_styles.css\" type=\"text/css\" />
							<script type=\"text/javascript\" src=\"" . JURI::root(true) . "/plugins/content/simplecomment/swfobject.js\"></script>
							<script type=\"text/javascript\">
							<!--
							function resizeSWF(nHeight){
								nHeight += \"px\";
								document.getElementById(\"resizer\").style.height = nHeight;
							}
							//-->
							</script>
							<style type=\"text/css\">
								#flashcontent{
									float: left;
									width: " . $scsSwfwidth . "px;
									margin: 0 auto;
									z-index: 10;
								}
								
								.flashcontent{
									padding-top: 20px;
								}
							</style>
						";
						$mainframe->addCustomHeadTag($headtag);
						
						if($juser->id){
							$flashvars	= "url=" . JURI::base() . "&d=" . $scsBender . "&p=" . base64_encode(JPATH_BASE) . "&id=" . base64_encode($article->id) . "&n=" . base64_encode($juser->name) . "&e=" . base64_encode($juser->email) . "&ui=" . base64_encode($juser->id) . "&ag=" . base64_encode($scsModGuest) . "&au=" . base64_encode($scsModUser . "&o=" . base64_encode($scsOrder));
						}else{
							$flashvars	= "url=" . JURI::base() . "&d=" . $scsBender . "&p=" . base64_encode(JPATH_BASE) . "&id=" . base64_encode($article->id) . "&n=" . base64_encode(0) . "&e=" . base64_encode(0) . "&ui=" . base64_encode(0) . "&ag=" . base64_encode($scsModGuest) . "&au=" . base64_encode($scsModUser) . "&o=" . base64_encode($scsOrder);
						}
						
						$simplecomment = "
							<a name=\"comment\"></a>
							<div class=\"flashcontent\"><div id=\"flashcontent\"><div style=\"clear: both;\"></div></div></div>
							<script type=\"text/javascript\" defer=\"defer\">
								// <![CDATA[
								var so = new SWFObject(\"" . JURI::root(true) . "/plugins/content/simplecomment/comment.swf\", \"resizer\", \"" . $pluginRegistry->scs_width . "\", \"420\", \"8\", \"#ffffff\");
								so.addParam(\"FlashVars\", \"" . $flashvars . "\");
								so.addParam(\"scale\", \"noscale\");
								so.addParam(\"quality\", \"high\");
								so.addParam(\"salign\", \"t\");
								so.addParam(\"menu\", \"false\");
								so.addParam(\"allowScriptAccess\", \"always\");
								so.write(\"flashcontent\");
								// ]]>
							</script>
						";
						$this->article->text = $this->article->text . $simplecomment;
					}else{
						$total	= $this->plgGetTotal($this->article->id);
						$link	= $this->plgGetUrl($this->article);
						if($scsReadMore == 1){
							if(strlen($scsReadMoreText) > 0){
								$readon = "<span class=\"readon\"><a href=\"$link\" title=\"" . $scsReadMoreText . "\">" . $scsReadMoreText . "</a><span> | ";
							}else{
								$readon = "<span class=\"readon\"><a href=\"$link\" title=\"" . JText::_('READMORE') . "\">" . JText::_('READMORE') . "</a><span> | ";
							}
						}else{
							$readon = "";
						}
						$addcomment = "<div class=\"simplecomment\"><div style=\"clear: both;\">" . $readon . "<span class=\"addcomment\"><a href=\"$link#comment\" title=\"" . JText::_('SC_ADD_COMMENT') . "\">" . JText::_('SC_ADD_COMMENT') . " ($total)</a></span></div></div>";
						$this->article->text = $this->article->text . $addcomment;
					}
				}
			}
		}
		
		function plgGetTotal(&$obj){
			$db	= & JFactory::getDBO();
			$q	=	'SELECT COUNT(*) AS total FROM #__comments ' .
					'WHERE articleid=' . $obj;
			$db->setQuery($q);
			return intval($db->loadResult());
		}
		
		function plgGetUrl(&$obj){
			$url ='Error, No URL';
			if (!is_null($obj)) {
				require_once( JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php' );
				$url = JRoute::_(ContentHelperRoute::getArticleRoute($obj->slug, $obj->catslug, $obj->sectionid));
				$uri     =& JURI::getInstance();
				$base  = $uri->toString( array('scheme', 'host', 'port'));
				$url = $base . $url;
				$url = JRoute::_($url, true, 0);
				return $url;
			}
			return $url;
		}
		
		function plgAllowContent(&$row){
			$plugin = & JPluginHelper::getPlugin('content', 'simplecomment');
			$pluginParams  = new JParameter( $plugin->params );
			$pluginRegistry  = $pluginParams->_registry['_default']['data'];
			$value_sec = 0;
			$value_cat = 0;
			$value_art = 0;
			
			//ALLOW SECTION
			if($pluginRegistry->sectionid !=''){
				$aAcceptedSectionsArray = array();
				$aAcceptedSectionsArray = explode(',',$pluginRegistry->sectionid);
				if(in_array($row->sectionid, $aAcceptedSectionsArray) != true){
					$value_sec = '1';
				}
				unset($aAcceptedSectionsArray);
			}
			
			//ALLOW CATEGORY
			if($pluginRegistry->catid !=''){
				$aAcceptedCategoryArray = array();
				$aAcceptedCategoryArray = explode(',',$pluginRegistry->catid);
				if(in_array($row->catid, $aAcceptedCategoryArray) != true){
					$value_cat = '1';
				}
				unset($aAcceptedCategoryArray);
			}
				
				
			//IGNORED ARTICLES
			if($pluginRegistry->articleid !=''){
				$aIgnoredArticleArray = array();
				$aIgnoredArticleArray = explode(',',$pluginRegistry->articleid);
				if(in_array($row->id, $aIgnoredArticleArray) ){
					$value_art = '1';
				}
				unset($aIgnoredArticleArray);
			}
			
			if( ($value_sec==1) || ($value_cat==1) || ($value_art==1) ){
				return false;
			}else{
				return true;
			}
			
		}
		
		function plgShowInIntro(&$obj){
			if (JString::strlen(strip_tags($obj->fulltext)) !='0'){
				if ((JRequest :: getVar('view')) == 'article'){
					return true;				
				}else{
					return false;
				}
			}else{
				return true;
			}
		}
		
		function plgShowContent(){
			$view_scs = JRequest :: getVar('view');
			switch ($view_scs){
				case 'article':
					return true;
					break;
				case 'frontpage':
					return true;
					break;
				case 'section':
					return true;
					break;
				case 'category':
					return true;
					break;
			}
		}
		
	}

?>